/*
 *
 *           MULti Core Operating System - Tiny / Multilayer Kernel
 *                      Device header for RA6 PSCU
 *
 *           Copyright (c) 2025 SPIRAL-TECH Co.,ltd All Rights Reserved.
 *
 *  File name       dv_ra6_pscu.h
 *
 *  Feb/02/2025     Created.
 *
 */

#ifndef _DV_RA6_PSCU_H_
#define _DV_RA6_PSCU_H_
#ifdef __cplusplus
extern "C" {
#endif

/* Base Address */

#if defined(_DV_RA6M5_H_) || defined(_DV_RA4M3_H_)
#define PSCU_BASE       0x400E0000      /* PSCU Base address */
#else
#error "I/O definition file is undefined."
#endif


/* registers */

typedef struct {
    UW  reserved;
    UW  PSARB;          /* Peripheral Security Attribution Register B          */
    UW  PSARC;          /* Peripheral Security Attribution Register C          */
    UW  PSARD;          /* Peripheral Security Attribution Register D          */
    UW  PSARE;          /* Peripheral Security Attribution Register E          */
    UW  MSSAR;          /* Module Stop Security Attribution Register           */
    UW  CFSAMONA;       /* Code Flash Security Attribution Monitor Register A  */
    UW  CFSAMONB;       /* Code Flash Security Attribution Monitor Register B  */
    UW  DFSAMON;        /* Data Flash Security Attribution Monitor Register    */
    UW  SSAMONA;        /* SRAM Security Attribution Monitor Register A        */
    UW  SSAMONB;        /* SRAM Security Attribution Monitor Register B        */
    UW  DLMMON;         /* Device Lifecycle Management State Monitor Register  */
} T_RA6_PSCU; 


/* Port access structure */

#define REG_PSCU    (*(volatile T_RA6_PSCU *)PSCU_BASE)


#ifdef __cplusplus
}
#endif
#endif /* _DV_RA6_PSCU_H_ */
