/*
 *
 *  MULti Core Operating System (MULCOS series)
 *               Error code definitions
 *
 *               Copyright (c) 2016-2018 SPIRAL-TECH Co.,ltd All Rights Reserved.
 *
 *  File name       mulcos_error.h
 *
 *  Mar/29/2018     Created.
 *  Aug/17/2022     Modified code name.
 *
 */

#ifndef MULCOS_ERROR_H
#define MULCOS_ERROR_H


#define ERR_OK                  0               /* 0x00000000 */
#define ERR_NG                  -1              /* 0xFFFFFFFF */

#define ERR_CMD                 -265            /* 0xFFFFFEF7 */
#define ERR_RSATR               -267            /* 0xFFFFFEF5 */
#define ERR_OBJNAME             -273            /* 0xFFFFFEEF */
#define ERR_IDCODE              -274            /* 0xFFFFFEEE */
#define ERR_CTEX                -281            /* 0xFFFFFEE7 */
#define ERR_ILUSE               -284            /* 0xFFFFFEE4 */
#define ERR_NOMEM               -289            /* 0xFFFFFEDF */
#define ERR_FULLID              -290            /* 0xFFFFFEDE */
#define ERR_EXIST               -297            /* 0xFFFFFED7 */
#define ERR_NOEXIST             -298            /* 0xFFFFFED6 */
#define ERR_OPNOVR              -299            /* 0xFFFFFED5 */
#define ERR_RELWAI              -305            /* 0xFFFFFECF */
#define ERR_NOFLG               -306            /* 0xFFFFFECE */
#define ERR_DELETE              -307            /* 0xFFFFFECD */
#define ERR_SPINLOCK            -517            /* 0xFFFFFDFB */
#define ERR_MOD                 -521            /* 0xFFFFFDF7 */
#define ERR_BUFSIZE             -529            /* 0xFFFFFDEF */
#define ERR_ILOBJ               -540            /* 0xFFFFFDE4 */
#define ERR_BUFEMP              -545            /* 0xFFFFFDDF */
#define ERR_FLGEXIST            -553            /* 0xFFFFFDD7 */
#define ERR_SEMOVR              -555            /* 0xFFFFFDD5 */
#define ERR_NOSEM               -562            /* 0xFFFFFDCE */
#define ERR_IBWEMP              -773            /* 0xFFFFFCFB */
#define ERR_NOSPT               -777            /* 0xFFFFFCF7 */
#define ERR_MEMEXIST            -785            /* 0xFFFFFCEF */
#define ERR_MSGFULL             -801            /* 0xFFFFFCDF */
#define ERR_SEMEXIST            -809            /* 0xFFFFFCD7 */
#define ERR_NOMSG               -818            /* 0xFFFFFCCE */
#define ERR_CORE                -1029           /* 0xFFFFFBFB */
#define ERR_PARAM               -1041           /* 0xFFFFFBEF */
#define ERR_MSGEXIST            -1065           /* 0xFFFFFBD7 */
#define ERR_ACTOVR              -1067           /* 0xFFFFFBD5 */
#define ERR_TIMEOUT             -1074           /* 0xFFFFFBCE */
#define ERR_DINIT               -1285           /* 0xFFFFFAFB */
#define ERR_ADDR                -1297           /* 0xFFFFFAEF */
#define ERR_NOINIT              -1321           /* 0xFFFFFAD7 */
#define ERR_UNMATCH             -1541           /* 0xFFFFF9FB */
#define ERR_OBJECT              -1577           /* 0xFFFFF9D7 */
#define ERR_SUSOVR              -1579           /* 0xFFFFF9D5 */
#define ERR_SIGNAL              -1797           /* 0xFFFFF8FB */
#define ERR_MAXOVR              -4095           /* 0xFFFFF001 */

#endif
